/* -*- mode: js2; js2-basic-offset: 4; indent-tabs-mode: nil -*- */
/*
 * ibus - The Input Bus
 *
 * Copyright (c) 2007-2011 Peng Huang <shawn.p.huang@gmail.com>
 * Copyright (c) 2010-2011 Takao Fujiwara <takao.fujiwara1@gmail.com>
 * Copyright (c) 2007-2011 Red Hat, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA  02111-1307  USA
 */

const IBus = imports.gi.IBus;
const Gtk = imports.gi.Gtk;
imports.searchPath.push('/usr/share/ibus/ui/gjs');
imports.searchPath.push('/usr/share/gnome-shell/js');

const SystemStatusLabelButton = imports._ibus.panelMenu.SystemStatusLabelButton;
const panel = imports.panel;

UIApplication.prototype = {
    _init: function(indicator) {
        this._bus = new IBus.Bus();
        if (this._bus.is_connected() == false) {
            printerr("ibus-daemon is not running");
            return;
        }
        this._bus.connect("disconnected", Gtk.main_quit);
        let owner = this._bus.get_name_owner(IBus.SERVICE_PANEL);
        if (owner != null) {
            this._bus.ask_release_name(IBus.SERVICE_PANEL, 1);
        }
        let match_rule = "type='signal',\
                         sender='org.freedesktop.IBus',\
                         path='/org/freedesktop/IBus'";
        this._bus.add_match(match_rule);
        this._panel = new panel.Panel(this._bus, indicator);
        this._bus.request_name(IBus.SERVICE_PANEL, 0);
    },

    run: function() {
        Gtk.main();
    },
};

function UIApplication(indicator) {
    this._init(indicator);
}

Indicator.prototype = {
    __proto__: SystemStatusLabelButton.prototype,

    _init: function() {
        SystemStatusLabelButton.prototype._init.call(this, null, "dummy", null);
        this._uiapplication = new UIApplication(this);
    },
};

function Indicator() {
    this._init.apply(this, arguments);
}
